#!/bin/bash

. config

STARTaddr=(0x`objdump -d vortex |grep 'call.*sestart'|awk '{print $1}'|sed -s 's/://g'`)
STARTendaddr="0x"`/bin/echo "obase=16; $((STARTaddr+5))"|bc`

ENDaddr=(0x`objdump -d vortex |grep 'call.*seend'|awk '{print $1}'|sed -s 's/://g'`)

SUCCESSaddr=(0x`objdump -d vortex |grep 'call.*sesuccess'|awk '{print $1}'|sed -s 's/://g'`)
SUCCESSendaddr="0x"`/bin/echo "obase=16; $((SUCCESSaddr+5))"|bc`
SUCCESSpreaddr="0x"`/bin/echo "obase=16; $((SUCCESSaddr-2))"|bc`

PROG="$FUZZBALL -random-seed $RANDOMSEED -solver $SOLVER -no-fail-on-huer -stp-path $STPPATH -solver-slow-time 10 $X87EMU -linux-syscalls -zero-memory -trace-assigns-string -trace-iterations -trace-syscalls ./vortex"

buf1len=6
CMD="$PROG -fuzz-start-addr $STARTaddr -fuzz-end-addr $ENDaddr -symbolic-region 0xc0fe0009+$buf1len -check-condition-at \"$SUCCESSpreaddr:R_EAX:reg32_t == 0xca000000:reg32_t\" -finish-on-nonfalse-cond -solve-final-pc -- ./vortex"

echo $CMD
echo "#!/bin/bash" > tmp.sh
echo $CMD >> tmp.sh
/usr/bin/time -f "Kernel %S User %U" -a bash tmp.sh
rm tmp.sh
