#!/bin/bash

. config

time $FUZZBALL -random-seed $RANDOMSEED -solver $SOLVER -no-fail-on-huer -stp-path $STPPATH -solver-slow-time 10 -linux-syscalls -zero-memory -trace-assigns-string -trace-iterations -trace-syscalls ./static-vortex -fuzz-start-addr 0x80485cc -fuzz-end-addr 0x8048649 -symbolic-region 0xc0fe0009+6 -check-condition-at "0x8048612:R_EAX:reg32_t == 0xca000000:reg32_t" -finish-on-nonfalse-cond -solve-final-pc -- ./static-vortex
